#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "dominoes"

const int MaxN = 10, MaxK = 1 << MaxN;

int f [MaxN + 1] [MaxK];
int k, m, n;

void recur (int isrc, int msrc, int idst, int mdst, int cur)
{
 while (msrc & (1 << cur)) cur++;
 if (cur == m) {f[idst][mdst] += f[isrc][msrc]; return;}
 recur (isrc, msrc, idst, mdst + (1 << cur), cur + 1);
 cur++;
 if (cur < m && !(msrc & (1 << cur)))
  recur (isrc, msrc, idst, mdst, cur + 1);
}

int main (void)
{
 int i, l;
 freopen (TASKNAME ".in", "r", stdin);
 freopen (TASKNAME ".out", "w", stdout);
 while (scanf (" %d %d", &m, &n) != EOF)
 {
  memset (f, 0, sizeof (f));
  f[0][0] = 1;
  k = 1 << m;
  for (i = 0; i < n; i++)
   for (l = 0; l < k; l++)
    if (f[i][l])
     recur (i, l, i + 1, 0, 0);
  printf ("%d\n", f[n][0]);
 }
 return 0;
}
