program PermutationByNumber;

{$APPTYPE CONSOLE}
{/$DEFINE CONSOLE_IO}
{$DEFINE DEBUG}

uses
  SysUtils;

const
  INPUT_FILE_NAME = 'permut.in';
  OUTPUT_FILE_NAME = 'permut.out';

var
  factorial: array[0..20] of int64;
  fin, fout: textfile;

  N, K: int64;
  used: array[1..50] of boolean;
  answ: array[1..50] of int64;


procedure initFactorial();
var i: integer;
begin
  factorial[0] := 1;
  factorial[1] := 1;
  for i := 2 to length(factorial) do begin
    factorial[i] := factorial[i-1]*int64(i);
    {$IFDEF DEBUG}
    if factorial[i]<0 then writeln(i);
    {$ENDIF}
    end;
end;

function GetFirstDigitNum(const sequenceLength, permutationNumber: int64): integer;
var
  i, j: integer;
  t, diff: int64;
  digitNumber: integer;
begin
    t := 1;
		diff := factorial[sequenceLength - 1];

    digitNumber := 1;
    result := 0;

  	while ((permutationNumber - t) >= diff) do begin
			t := t + diff;
			inc(digitNumber);
		  end;

    result := digitNumber;
end;

procedure evaluate();
var
  l, i, j, digitNumber, curPermNum: integer;
begin

  curPermNum := k;


  for l := 1 to N do begin

    digitNumber := GetFirstDigitNum(N - l + 1, curPermNum);

    curPermNum := curPermNum - ((digitNumber-1)*factorial[N-l]);

    i := 0;
    j := 1;

    while (i <> digitNumber) do begin
      if not used[j] then inc(i);
      inc(j);
      end;

    if j<>1 then dec(j);


    used[j] := true;

    answ[l] := j;

    end;

end;


var i: integer;
begin

  {/$IFDEF CONSOLE_IO
  assign(fin, input); reset(fin);
  assign(fout, output); rewrite(fout);
  $ELSE}
  assign(fin, INPUT_FILE_NAME); reset(fin);
  assign(fout, OUTPUT_FILE_NAME); rewrite(fout);
  {/$ENDIF}

  readln(fin, N, K);
  close(fin);
  initFactorial();
  evaluate();

  if ((N > length(factorial))or(K > factorial[N])or(K<1)) then
    writeln(fout, 'Invalid number!')
  else begin
    for i := 1 to N do begin
      write(fout, answ[i], ' ');
      end;
    end;


  close(fout);
end.
